unit uFenster;
// ********************************************************************
// K L A S S E : TFensterFrm
// --------------------------------------------------------------------
// Version     : 1.x
// Autor       : S. Spolwig, OSZ-Handel, Berlin
// Beschreibung: Die Klasse TFensterFrm ist das GUI fr Ein-/Ausgabe-
//               operationen des Benutzer
//
// Compiler    : Delphi 4.0
// Aenderungen : 1.0  - 03-FEB-01 - Zahl
//               1.1  -           - Addition 
//               1.2  -           - Sub, Mult, Div, Vorzeichen, CE
//               1.3  -           - Pot.
// ********************************************************************
interface
// ====================================================================
uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls,
  uRechner;

type
  TFensterFrm = class(TForm)
    GehaeusePnl : TPanel;
    DisplayEdt  : TEdit;
    NullBtn     : TButton;
    EinsBtn     : TButton;
    ZweiBtn     : TButton;
    DreiBtn     : TButton;
    VierBtn     : TButton;
    FuenfBtn    : TButton;
    SechsBtn    : TButton;
    SiebenBtn   : TButton;
    AchtBtn     : TButton;
    NeunBtn     : TButton;
    GleichBtn   : TButton;
    PlusBtn     : TButton;
    CanceAllBtn : TButton;
    MinusBtn    : TButton;
    MultBtn     : TButton;
    DivBtn      : TButton;
    CEBtn       : TButton;
    VorzeichBtn : TButton;
    ExpoBtn     : TButton;

    procedure FormCreate(Sender: TObject);
    procedure EinsBtnClick(Sender: TObject);
    procedure ZweiBtnClick(Sender: TObject);
    procedure GleichBtnClick(Sender: TObject);
    procedure DreiBtnClick(Sender: TObject);
    procedure VierBtnClick(Sender: TObject);
    procedure FuenfBtnClick(Sender: TObject);
    procedure SechsBtnClick(Sender: TObject);
    procedure SiebenBtnClick(Sender: TObject);
    procedure AchtBtnClick(Sender: TObject);
    procedure NeunBtnClick(Sender: TObject);
    procedure NullBtnClick(Sender: TObject);
    procedure CanceAllBtnClick(Sender: TObject);
    procedure PlusBtnClick(Sender: TObject);
    procedure MinusBtnClick(Sender: TObject);
    procedure MultBtnClick(Sender: TObject);
    procedure DivBtnClick(Sender: TObject);
    procedure CEBtnClick(Sender: TObject);
    procedure VorzeichBtnClick(Sender: TObject);
    procedure ExpoBtnClick(Sender: TObject);
   private
    procedure DisplayAktualisieren (za: real);
   public
  end;

var
  FensterFrm: TFensterFrm;
  Rechner   : TRechner; // Obj. deklarieren

implementation
// ====================================================================
{$R *.DFM}

procedure TFensterFrm.FormCreate(Sender: TObject);
// --------------------------------------------------------------------
begin
  Rechner := TRechner.Create;
  Rechner.Init;
end;


// ==================Ziffern ==========================================

procedure TFensterFrm.NullBtnClick(Sender: TObject);
begin
  Rechner.SetZiffer(0);
  DisplayAktualisieren (Rechner.GetZahl);
end;

procedure TFensterFrm.EinsBtnClick(Sender: TObject);
// --------------------------------------------------------------------
begin
  Rechner.SetZiffer(1);
  DisplayAktualisieren (Rechner.GetZahl);
end;

procedure TFensterFrm.ZweiBtnClick(Sender: TObject);
// --------------------------------------------------------------------
begin
  Rechner.SetZiffer(2);
  DisplayAktualisieren(Rechner.GetZahl);
end;


procedure TFensterFrm.DreiBtnClick(Sender: TObject);
// --------------------------------------------------------------------
begin
  Rechner.SetZiffer(3);
  DisplayAktualisieren(Rechner.GetZahl);
end;


procedure TFensterFrm.VierBtnClick(Sender: TObject);
// --------------------------------------------------------------------
begin
  Rechner.SetZiffer(4);
  DisplayAktualisieren(Rechner.GetZahl);
end;

procedure TFensterFrm.FuenfBtnClick(Sender: TObject);
// --------------------------------------------------------------------
begin
  Rechner.SetZiffer(5);
  DisplayAktualisieren(Rechner.GetZahl);
end;

procedure TFensterFrm.SechsBtnClick(Sender: TObject);
// --------------------------------------------------------------------
begin
  Rechner.SetZiffer(6);
  DisplayAktualisieren(Rechner.GetZahl);
end;

procedure TFensterFrm.SiebenBtnClick(Sender: TObject);
// --------------------------------------------------------------------
begin
 Rechner.SetZiffer(7);
  DisplayAktualisieren(Rechner.GetZahl);
end;

procedure TFensterFrm.AchtBtnClick(Sender: TObject);
// --------------------------------------------------------------------
begin
  Rechner.SetZiffer(8);
  DisplayAktualisieren(Rechner.GetZahl);
end;

procedure TFensterFrm.NeunBtnClick(Sender: TObject);
// --------------------------------------------------------------------
begin
  Rechner.SetZiffer(9);
  DisplayAktualisieren(Rechner.GetZahl);
end;

// ==================Operatoren =======================================

procedure TFensterFrm.PlusBtnClick(Sender: TObject);
// --------------------------------------------------------------------
begin
  Rechner.OperationAusfuehren;
  DisplayAktualisieren(Rechner.GetAkku);
  Rechner.SetOperator(1);     // + fuer die nchste OP.
end;

procedure TFensterFrm.MinusBtnClick(Sender: TObject);
// --------------------------------------------------------------------
begin
  Rechner.OperationAusfuehren;
  DisplayAktualisieren(Rechner.GetAkku);
  Rechner.SetOperator(2);     // -
end;


procedure TFensterFrm.MultBtnClick(Sender: TObject);
// --------------------------------------------------------------------
begin
  Rechner.OperationAusfuehren;
  DisplayAktualisieren(Rechner.GetAkku);
  Rechner.SetOperator(3);     //mult.
end;


procedure TFensterFrm.DivBtnClick(Sender: TObject);
// --------------------------------------------------------------------
begin
  Rechner.OperationAusfuehren;
  DisplayAktualisieren(Rechner.GetAkku);
  Rechner.SetOperator(4);     // Div.
end;

procedure TFensterFrm.ExpoBtnClick(Sender: TObject);
// --------------------------------------------------------------------
begin
  Rechner.OperationAusfuehren;
  DisplayAktualisieren(Rechner.GetAkku);
  Rechner.SetOperator(5);     // pot.
end;


procedure TFensterFrm.GleichBtnClick(Sender: TObject);
// --------------------------------------------------------------------
begin
  Rechner.OperationAusfuehren;  // die letzte Operation
  DisplayAktualisieren(Rechner.GetAkku);
  Rechner.SetOperator(6);     // =
end;


procedure TFensterFrm.CanceAllBtnClick(Sender: TObject);
// --------------------------------------------------------------------
begin
  Rechner.Init;
  DisplayEdt.Text := '';
end;

procedure TFensterFrm.CEBtnClick(Sender: TObject);
// --------------------------------------------------------------------
begin
  Rechner.ResetZahl;
  DisplayAktualisieren(Rechner.GetZahl);
end;

procedure TFensterFrm.VorzeichBtnClick(Sender: TObject);
// --------------------------------------------------------------------
begin
  Rechner.VorzeichenAendern;
  DisplayAktualisieren(Rechner.GetZahl);
end;

procedure TFensterFrm.DisplayAktualisieren  (za: real);
// --------------------------------------------------------------------
// Aufgabe: Wert der uebergebenen Zahl anzeigen
begin
  DisplayEdt.Text := floattostr(za);
end;


end.
