UNIT uRechner;
// ********************************************************************
// K L A S S E : TRechner
// --------------------------------------------------------------------
// Version     : 1.x
// Autor       : S. Spolwig, OSZ Handel, Berlin
// Beschreibung: Die Klasse TRechner bildet den Rechenchip ab, der die
//               Rechenoperationen ausfhrt
// Compiler    : Delphi 4.0
// Aenderungen : 1.3  - 06-FEB-01
// ********************************************************************

INTERFACE
// ====================================================================

type
  TRechner = class(TObject)
   private
    Ziffer   : 0..9;      // erstmal nur Ganzzahlen eingeben
    Zahl     : real;
    Akku     : real;      // Zwischenergebnis
    Operator : 1..6;      // +, -, *, /, ^, =  durchnumeriert
   public
    constructor Create;
    procedure Init;
    procedure SetZiffer (eineZiffer : integer);
    procedure SetOperator (op : integer);
    function  GetZahl : real;
    function  GetAkku : real;

    procedure ZahlAktualisieren;
    procedure OperationAusfuehren;
    procedure Addieren;
    procedure Subtrahieren;
    procedure Multiplizieren;
    procedure Dividieren;
    procedure Potenzieren;
    procedure ResetZahl;
    procedure VorzeichenAendern;
  end;

(* -------------------- B e s c h r e i b u n g -------------------------

Oberklasse    : -
Bezugsklassen : .


Methoden
--------

Init
   Auftrag: alle Werte auf Null setzen

SetZiffer (eineZiffer : integer);
  Auftrag: Attribut Ziffer einen Wert  uebergeben

GetZahl : integer;
  Auftrag: Wert der Zahl zurckliefern


ZahlAktualisieren;
   Auftrag: Zahl aus den Ziffern zusammensetzen und Wert berechnen

OperationAusfuehren
  Auftrag: je nach aktuellem Operator die entsprechende Operation
           (Addieren, ..) aufrufen

Addieren usw.
  Aufgabe: die jeweilige Berechnung  durchfhren
----------------------------------------------------------------------- *)


IMPLEMENTATION
// ====================================================================

constructor TRechner.Create;
// ---------------------------------------------------------------------
begin
  inherited Create; // was von TObject kommt
end;


procedure TRechner.Init;
// --------------------------------------------------------------------
begin
  Ziffer := 0;
  Zahl   := 0;
  Akku   := 0;
  Operator := 1; // die 1. Zahl ist immer plus
end;

procedure TRechner.SetZiffer  (eineZiffer : integer);
// --------------------------------------------------------------------
begin
  Ziffer := eineZiffer;
  ZahlAktualisieren;
end;

procedure TRechner.SetOperator (op : integer);
// --------------------------------------------------------------------
begin
  Operator :=op;
end;

procedure TRechner.ZahlAktualisieren;
// --------------------------------------------------------------------
begin
  Zahl := (Zahl * 10) + Ziffer;
end;


function  TRechner.GetZahl : real;
// --------------------------------------------------------------------
begin
  Result := Zahl;
end;


function  TRechner.GetAkku : real;
// --------------------------------------------------------------------
begin
  Result := Akku;
end;


procedure TRechner.OperationAusfuehren;
// --------------------------------------------------------------------
begin
  case Operator of

   1 : Addieren;
   2 : Subtrahieren;
   3 : Multiplizieren;
   4 : Dividieren;
   5 : Potenzieren;
   6 : ;       // =
  end;
  ResetZahl;            // damit nicht mehrfach !!
end;


procedure TRechner.Addieren;
// --------------------------------------------------------------------
begin
  Akku := Akku + Zahl;
end;

procedure TRechner.Subtrahieren;
// --------------------------------------------------------------------
begin
  Akku := Akku - Zahl;
end;

procedure TRechner.Multiplizieren;
// --------------------------------------------------------------------
begin
  Akku := Akku * Zahl;
end;

procedure TRechner.Dividieren;
// --------------------------------------------------------------------
begin
  if Zahl = 0
  then
  else Akku := Akku / Zahl;
end;

procedure TRechner.Potenzieren;
// --------------------------------------------------------------------
var
  i : integer;
  Basis : real;

  begin
  if zahl = 0
  then akku := 1
  else
    if zahl = 1
    then        // akku!
    else
      begin
        Basis := akku;
        akku := akku * akku;

        if round(zahl) > zahl   // auf ganze Zahl rund, ev. vermindern
        then zahl := zahl - 1;

        for i := 1 to round(Zahl - 2) do  // 2 mal is schon oben erledigt
        begin
          Akku := Akku * basis;
        end;
      end;
end;

procedure TRechner.ResetZahl;
// --------------------------------------------------------------------
begin
  Zahl := 0;
end;

procedure TRechner.VorzeichenAendern;
// --------------------------------------------------------------------
begin
  Zahl := 0 - Zahl;
end;


END.
